//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class Vec3 : global::System.IDisposable {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;
  protected bool swigCMemOwn;

  internal Vec3(global::System.IntPtr cPtr, bool cMemoryOwn) {
    swigCMemOwn = cMemoryOwn;
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(Vec3 obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~Vec3() {
    Dispose();
  }

  public virtual void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_Vec3(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
    }
  }

  public Vec3() : this(OpenMMSwigPINVOKE.new_Vec3__SWIG_0(), true) {
  }

  public Vec3(double x, double y, double z) : this(OpenMMSwigPINVOKE.new_Vec3__SWIG_1(x, y, z), true) {
  }

  public double dot(Vec3 rhs) {
    double ret = OpenMMSwigPINVOKE.Vec3_dot(swigCPtr, Vec3.getCPtr(rhs));
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public Vec3 cross(Vec3 rhs) {
    Vec3 ret = new Vec3(OpenMMSwigPINVOKE.Vec3_cross(swigCPtr, Vec3.getCPtr(rhs)), true);
    if (OpenMMSwigPINVOKE.SWIGPendingException.Pending) throw OpenMMSwigPINVOKE.SWIGPendingException.Retrieve();
    return ret;
  }

  public double x() {
    double ret = OpenMMSwigPINVOKE.Vec3_x(swigCPtr);
    return ret;
  }

  public double y() {
    double ret = OpenMMSwigPINVOKE.Vec3_y(swigCPtr);
    return ret;
  }

  public double z() {
    double ret = OpenMMSwigPINVOKE.Vec3_z(swigCPtr);
    return ret;
  }

}

}
